package com.company.testapp.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.*;
import jakarta.validation.constraints.NotNull;

import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "GDKM_ADD_ON_GROUP", indexes = {
        @Index(name = "IDX_GDKM_ADD_ON_GROUP_PRODUCT", columnList = "PRODUCT_ID")
})
@Entity(name = "gdkm_AddOnGroup")
public class AddOnGroup {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @InstanceName
    @Column(name = "GROUP_ID", nullable = false)
    @NotNull
    private String groupId;

    @Column(name = "NAME", nullable = false)
    @NotNull
    private String name;

    @Column(name = "MANDATORY")
    private Boolean mandatory;

    @Column(name = "MIN_")
    private Integer min;

    @Column(name = "MAX_")
    private Integer max;

    @OnDeleteInverse(DeletePolicy.CASCADE)
    @JoinColumn(name = "PRODUCT_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Product product;

    @ManyToMany(mappedBy = "addOnGroups")
    private List<AddOnProduct> addOnProducts;

    public List<AddOnProduct> getAddOnProducts() {
        return addOnProducts;
    }

    public void setAddOnProducts(List<AddOnProduct> addOnProducts) {
        this.addOnProducts = addOnProducts;
    }

    public String getGroupId() {
        return groupId;
    }

    public void setGroupId(String groupId) {
        this.groupId = groupId;
    }

    public Product getProduct() {
        return product;
    }

    public void setProduct(Product product) {
        this.product = product;
    }

    public Integer getMax() {
        return max;
    }

    public void setMax(Integer max) {
        this.max = max;
    }

    public Integer getMin() {
        return min;
    }

    public void setMin(Integer min) {
        this.min = min;
    }

    public Boolean getMandatory() {
        return mandatory;
    }

    public void setMandatory(Boolean mandatory) {
        this.mandatory = mandatory;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}