package com.company.testapp.entity;

import io.jmix.core.FileRef;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.*;
import jakarta.validation.constraints.NotNull;

import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "GDKM_ADD_ON_PRODUCT")
@Entity(name = "gdkm_AddOnProduct")
public class AddOnProduct {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @InstanceName
    @Column(name = "ADD_ON_ID", nullable = false)
    @NotNull
    private String addOnId;

    @Column(name = "NAME", nullable = false)
    @NotNull
    private String name;

    @Column(name = "IMAGE", length = 1024)
    private FileRef image;

    @Column(name = "PRICE", nullable = false)
    @NotNull
    private Double price;

    @JoinTable(name = "GDKM_ADD_ON_PRODUCT_ADD_ON_GROUP_LINK",
            joinColumns = @JoinColumn(name = "ADD_ON_PRODUCT_ID"),
            inverseJoinColumns = @JoinColumn(name = "ADD_ON_GROUP_ID"))
    @ManyToMany
    private List<AddOnGroup> addOnGroups;

    public List<AddOnGroup> getAddOnGroups() {
        return addOnGroups;
    }

    public void setAddOnGroups(List<AddOnGroup> addOnGroups) {
        this.addOnGroups = addOnGroups;
    }

    public String getAddOnId() {
        return addOnId;
    }

    public void setAddOnId(String addOnId) {
        this.addOnId = addOnId;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public Double getPrice() {
        return price;
    }

    public void setPrice(Double price) {
        this.price = price;
    }

    public FileRef getImage() {
        return image;
    }

    public void setImage(FileRef image) {
        this.image = image;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

}