package com.company.testapp.view.addongroup;

import com.company.testapp.entity.AddOnGroup;
import com.company.testapp.entity.AddOnProduct;
import com.company.testapp.view.addonproduct.AddOnProductListView;
import com.company.testapp.view.main.MainView;
import com.vaadin.flow.router.Route;
import io.jmix.flowui.DialogWindows;
import io.jmix.flowui.component.grid.DataGrid;
import io.jmix.flowui.kit.action.ActionPerformedEvent;
import io.jmix.flowui.model.CollectionPropertyContainer;
import io.jmix.flowui.model.DataContext;
import io.jmix.flowui.view.*;
import org.springframework.beans.factory.annotation.Autowired;

@Route(value = "addOnGroups/:id", layout = MainView.class)
@ViewController(id = "gdkm_AddOnGroup.detail")
@ViewDescriptor(path = "add-on-group-detail-view.xml")
@EditedEntityContainer("addOnGroupDc")
public class AddOnGroupDetailView extends StandardDetailView<AddOnGroup> {
    @Autowired
    private DialogWindows dialogWindows;
    @ViewComponent
    private DataGrid<AddOnProduct> addOnProductsDataGrid;
    @ViewComponent
    private DataContext dataContext;
    @ViewComponent
    private CollectionPropertyContainer<AddOnProduct> addOnProductsDc;

    @Subscribe("addOnProductsDataGrid.add")
    public void onAddOnProductsDataGridAdd(final ActionPerformedEvent event) {
        DialogWindow<AddOnProductListView> window = dialogWindows.lookup(addOnProductsDataGrid)
                .withSelectHandler(addOnProducts -> {
                    if(getEditedEntity().getAddOnProducts() == null)
                        getEditedEntity().setAddOnProducts(addOnProducts.stream().toList());
                    else {
                        addOnProductsDc.getMutableItems().addAll(addOnProducts);
                    }
                })
                .withViewClass(AddOnProductListView.class)
                .build();
        window.getView().setAddonGroup(getEditedEntity());
        window.open();
    }
}