package com.company.testapp.view.addonproduct;

import com.company.testapp.entity.AddOnGroup;
import com.company.testapp.entity.AddOnProduct;
import com.company.testapp.view.main.MainView;
import com.vaadin.flow.data.selection.SelectionEvent;
import com.vaadin.flow.router.Route;
import io.jmix.flowui.component.grid.DataGrid;
import io.jmix.flowui.view.*;

@Route(value = "addOnProducts", layout = MainView.class)
@ViewController(id = "gdkm_AddOnProduct.list")
@ViewDescriptor(path = "add-on-product-list-view.xml")
@LookupComponent("addOnProductsDataGrid")
@DialogMode(width = "64em")
public class AddOnProductListView extends StandardListView<AddOnProduct> {
    private AddOnGroup addonGroup;

    public void setAddonGroup(AddOnGroup editedEntity) {
        this.addonGroup = editedEntity;
    }

    @Subscribe("addOnProductsDataGrid")
    public void onAddOnProductsDataGridSelection(final SelectionEvent<DataGrid<AddOnProduct>, AddOnProduct> event) {
        event.getAllSelectedItems().forEach(addOnProduct -> {
            if (!addOnProduct.getAddOnGroups().contains(addonGroup)) {
                addOnProduct.getAddOnGroups().add(addonGroup);
            }
        });
    }

}