package com.company.testapp.view.product;

import com.company.testapp.entity.AddOnGroup;
import com.company.testapp.entity.Product;
import com.company.testapp.view.addongroup.AddOnGroupDetailView;
import com.company.testapp.view.main.MainView;
import com.vaadin.flow.router.Route;
import io.jmix.core.DataManager;
import io.jmix.flowui.DialogWindows;
import io.jmix.flowui.component.grid.DataGrid;
import io.jmix.flowui.kit.action.ActionPerformedEvent;
import io.jmix.flowui.model.DataContext;
import io.jmix.flowui.view.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Objects;

@Route(value = "products/:id", layout = MainView.class)
@ViewController(id = "gdkm_Product.detail")
@ViewDescriptor(path = "product-detail-view.xml")
@EditedEntityContainer("productDc")
public class ProductDetailView extends StandardDetailView<Product> {

    private static final Logger log = LoggerFactory.getLogger(ProductDetailView.class);
    @Autowired
    private DialogWindows dialogWindows;
    @ViewComponent
    private DataGrid<AddOnGroup> addOnGroupsDataGrid;
    @ViewComponent
    private DataContext dataContext;
    @Autowired
    private DataManager dataManager;

    @Subscribe("addOnGroupsDataGrid.create")
    public void onAddOnGroupsDataGridCreate(final ActionPerformedEvent event) {
        dialogWindows.detail(addOnGroupsDataGrid)
                .withViewClass(AddOnGroupDetailView.class)
                .newEntity()
                .withInitializer(entity -> entity.setProduct(getEditedEntity()))
                .withParentDataContext(dataContext)
                .open();
    }

    @Subscribe("addOnGroupsDataGrid.edit")
    public void onAddOnGroupsDataGridEdit(final ActionPerformedEvent event) {
        dialogWindows.detail(addOnGroupsDataGrid)
                .withViewClass(AddOnGroupDetailView.class)
                .editEntity(Objects.requireNonNull(addOnGroupsDataGrid.getSingleSelectedItem()))
                .withInitializer(entity -> entity.setProduct(getEditedEntity()))
                .withParentDataContext(dataContext)
                .open();
    }
}